Merge branch 'rs/use-argv-array-in-child-process'
[git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode.  "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user.  As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed.  A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands.  When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it.  The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 #     # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated.  It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit.  (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be.  This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file.  When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited.  When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s.  The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87         for strategy_opt in '"$strategy_opts"'
88         do
89                 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90         done
91 '
92
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
95
96 comment_char=$(git config --get core.commentchar 2>/dev/null)
97 case "$comment_char" in
98 '' | auto)
99         comment_char="#"
100         ;;
101 ?)
102         ;;
103 *)
104         comment_char=$(echo "$comment_char" | cut -c1)
105         ;;
106 esac
107
108 warn () {
109         printf '%s\n' "$*" >&2
110 }
111
112 # Output the commit message for the specified commit.
113 commit_message () {
114         git cat-file commit "$1" | sed "1,/^$/d"
115 }
116
117 orig_reflog_action="$GIT_REFLOG_ACTION"
118
119 comment_for_reflog () {
120         case "$orig_reflog_action" in
121         ''|rebase*)
122                 GIT_REFLOG_ACTION="rebase -i ($1)"
123                 export GIT_REFLOG_ACTION
124                 ;;
125         esac
126 }
127
128 last_count=
129 mark_action_done () {
130         sed -e 1q < "$todo" >> "$done"
131         sed -e 1d < "$todo" >> "$todo".new
132         mv -f "$todo".new "$todo"
133         new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
134         echo $new_count >"$msgnum"
135         total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
136         echo $total >"$end"
137         if test "$last_count" != "$new_count"
138         then
139                 last_count=$new_count
140                 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
141                 test -z "$verbose" || echo
142         fi
143 }
144
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action () {
149         tail -n 1 "$done" | cat - "$todo" >"$todo".new
150         sed -e \$d <"$done" >"$done".new
151         mv -f "$todo".new "$todo"
152         mv -f "$done".new "$done"
153 }
154
155 append_todo_help () {
156         gettext "
157 Commands:
158 p, pick = use commit
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
165
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace --comment-lines >>"$todo"
168
169         if test $(get_missing_commit_check_level) = error
170         then
171                 gettext "
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace --comment-lines >>"$todo"
174         else
175                 gettext "
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace --comment-lines >>"$todo"
178         fi
179 }
180
181 make_patch () {
182         sha1_and_parents="$(git rev-list --parents -1 "$1")"
183         case "$sha1_and_parents" in
184         ?*' '?*' '?*)
185                 git diff --cc $sha1_and_parents
186                 ;;
187         ?*' '?*)
188                 git diff-tree -p "$1^!"
189                 ;;
190         *)
191                 echo "Root commit"
192                 ;;
193         esac > "$state_dir"/patch
194         test -f "$msg" ||
195                 commit_message "$1" > "$msg"
196         test -f "$author_script" ||
197                 get_author_ident_from_commit "$1" > "$author_script"
198 }
199
200 die_with_patch () {
201         echo "$1" > "$state_dir"/stopped-sha
202         make_patch "$1"
203         die "$2"
204 }
205
206 exit_with_patch () {
207         echo "$1" > "$state_dir"/stopped-sha
208         make_patch $1
209         git rev-parse --verify HEAD > "$amend"
210         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
211         warn "$(eval_gettext "\
212 You can amend the commit now, with
213
214         git commit --amend \$gpg_sign_opt_quoted
215
216 Once you are satisfied with your changes, run
217
218         git rebase --continue")"
219         warn
220         exit $2
221 }
222
223 die_abort () {
224         apply_autostash
225         rm -rf "$state_dir"
226         die "$1"
227 }
228
229 has_action () {
230         test -n "$(git stripspace --strip-comments <"$1")"
231 }
232
233 is_empty_commit() {
234         tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
235                 sha1=$1
236                 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
237         }
238         ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
239                 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
240         test "$tree" = "$ptree"
241 }
242
243 is_merge_commit()
244 {
245         git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
246 }
247
248 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
249 # GIT_AUTHOR_DATE exported from the current environment.
250 do_with_author () {
251         (
252                 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
253                 "$@"
254         )
255 }
256
257 git_sequence_editor () {
258         if test -z "$GIT_SEQUENCE_EDITOR"
259         then
260                 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
261                 if [ -z "$GIT_SEQUENCE_EDITOR" ]
262                 then
263                         GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
264                 fi
265         fi
266
267         eval "$GIT_SEQUENCE_EDITOR" '"$@"'
268 }
269
270 pick_one () {
271         ff=--ff
272
273         case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
274         case "$force_rebase" in '') ;; ?*) ff= ;; esac
275         output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
276
277         if is_empty_commit "$sha1"
278         then
279                 empty_args="--allow-empty"
280         fi
281
282         test -d "$rewritten" &&
283                 pick_one_preserving_merges "$@" && return
284         output eval git cherry-pick $allow_rerere_autoupdate \
285                         ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
286                         "$strategy_args" $empty_args $ff "$@"
287
288         # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
289         # previous task so this commit is not lost.
290         ret=$?
291         case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
292         return $ret
293 }
294
295 pick_one_preserving_merges () {
296         fast_forward=t
297         case "$1" in
298         -n)
299                 fast_forward=f
300                 sha1=$2
301                 ;;
302         *)
303                 sha1=$1
304                 ;;
305         esac
306         sha1=$(git rev-parse $sha1)
307
308         if test -f "$state_dir"/current-commit
309         then
310                 if test "$fast_forward" = t
311                 then
312                         while read current_commit
313                         do
314                                 git rev-parse HEAD > "$rewritten"/$current_commit
315                         done <"$state_dir"/current-commit
316                         rm "$state_dir"/current-commit ||
317                                 die "$(gettext "Cannot write current commit's replacement sha1")"
318                 fi
319         fi
320
321         echo $sha1 >> "$state_dir"/current-commit
322
323         # rewrite parents; if none were rewritten, we can fast-forward.
324         new_parents=
325         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
326         if test "$pend" = " "
327         then
328                 pend=" root"
329         fi
330         while [ "$pend" != "" ]
331         do
332                 p=$(expr "$pend" : ' \([^ ]*\)')
333                 pend="${pend# $p}"
334
335                 if test -f "$rewritten"/$p
336                 then
337                         new_p=$(cat "$rewritten"/$p)
338
339                         # If the todo reordered commits, and our parent is marked for
340                         # rewriting, but hasn't been gotten to yet, assume the user meant to
341                         # drop it on top of the current HEAD
342                         if test -z "$new_p"
343                         then
344                                 new_p=$(git rev-parse HEAD)
345                         fi
346
347                         test $p != $new_p && fast_forward=f
348                         case "$new_parents" in
349                         *$new_p*)
350                                 ;; # do nothing; that parent is already there
351                         *)
352                                 new_parents="$new_parents $new_p"
353                                 ;;
354                         esac
355                 else
356                         if test -f "$dropped"/$p
357                         then
358                                 fast_forward=f
359                                 replacement="$(cat "$dropped"/$p)"
360                                 test -z "$replacement" && replacement=root
361                                 pend=" $replacement$pend"
362                         else
363                                 new_parents="$new_parents $p"
364                         fi
365                 fi
366         done
367         case $fast_forward in
368         t)
369                 output warn "$(eval_gettext "Fast-forward to \$sha1")"
370                 output git reset --hard $sha1 ||
371                         die "$(eval_gettext "Cannot fast-forward to \$sha1")"
372                 ;;
373         f)
374                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
375
376                 if [ "$1" != "-n" ]
377                 then
378                         # detach HEAD to current parent
379                         output git checkout $first_parent 2> /dev/null ||
380                                 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
381                 fi
382
383                 case "$new_parents" in
384                 ' '*' '*)
385                         test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
386
387                         # redo merge
388                         author_script_content=$(get_author_ident_from_commit $sha1)
389                         eval "$author_script_content"
390                         msg_content="$(commit_message $sha1)"
391                         # No point in merging the first parent, that's HEAD
392                         new_parents=${new_parents# $first_parent}
393                         merge_args="--no-log --no-ff"
394                         if ! do_with_author output eval \
395                         'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
396                                 $allow_rerere_autoupdate $merge_args \
397                                 $strategy_args -m "$msg_content" $new_parents'
398                         then
399                                 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
400                                 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
401                         fi
402                         echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
403                         ;;
404                 *)
405                         output eval git cherry-pick $allow_rerere_autoupdate \
406                                 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
407                                 "$strategy_args" "$@" ||
408                                 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
409                         ;;
410                 esac
411                 ;;
412         esac
413 }
414
415 this_nth_commit_message () {
416         n=$1
417         eval_gettext "This is the commit message #\${n}:"
418 }
419
420 skip_nth_commit_message () {
421         n=$1
422         eval_gettext "The commit message #\${n} will be skipped:"
423 }
424
425 update_squash_messages () {
426         if test -f "$squash_msg"; then
427                 mv "$squash_msg" "$squash_msg".bak || exit
428                 count=$(($(sed -n \
429                         -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
430                         -e "q" < "$squash_msg".bak)+1))
431                 {
432                         printf '%s\n' "$comment_char $(eval_ngettext \
433                                 "This is a combination of \$count commit." \
434                                 "This is a combination of \$count commits." \
435                                 $count)"
436                         sed -e 1d -e '2,/^./{
437                                 /^$/d
438                         }' <"$squash_msg".bak
439                 } >"$squash_msg"
440         else
441                 commit_message HEAD >"$fixup_msg" ||
442                 die "$(eval_gettext "Cannot write \$fixup_msg")"
443                 count=2
444                 {
445                         printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
446                         printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
447                         echo
448                         cat "$fixup_msg"
449                 } >"$squash_msg"
450         fi
451         case $1 in
452         squash)
453                 rm -f "$fixup_msg"
454                 echo
455                 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
456                 echo
457                 commit_message $2
458                 ;;
459         fixup)
460                 echo
461                 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
462                 echo
463                 # Change the space after the comment character to TAB:
464                 commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
465                 ;;
466         esac >>"$squash_msg"
467 }
468
469 peek_next_command () {
470         git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
471 }
472
473 # A squash/fixup has failed.  Prepare the long version of the squash
474 # commit message, then die_with_patch.  This code path requires the
475 # user to edit the combined commit message for all commits that have
476 # been squashed/fixedup so far.  So also erase the old squash
477 # messages, effectively causing the combined commit to be used as the
478 # new basis for any further squash/fixups.  Args: sha1 rest
479 die_failed_squash() {
480         sha1=$1
481         rest=$2
482         mv "$squash_msg" "$msg" || exit
483         rm -f "$fixup_msg"
484         cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
485         warn
486         warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
487         die_with_patch $sha1 ""
488 }
489
490 flush_rewritten_pending() {
491         test -s "$rewritten_pending" || return
492         newsha1="$(git rev-parse HEAD^0)"
493         sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
494         rm -f "$rewritten_pending"
495 }
496
497 record_in_rewritten() {
498         oldsha1="$(git rev-parse $1)"
499         echo "$oldsha1" >> "$rewritten_pending"
500
501         case "$(peek_next_command)" in
502         squash|s|fixup|f)
503                 ;;
504         *)
505                 flush_rewritten_pending
506                 ;;
507         esac
508 }
509
510 do_pick () {
511         sha1=$1
512         rest=$2
513         if test "$(git rev-parse HEAD)" = "$squash_onto"
514         then
515                 # Set the correct commit message and author info on the
516                 # sentinel root before cherry-picking the original changes
517                 # without committing (-n).  Finally, update the sentinel again
518                 # to include these changes.  If the cherry-pick results in a
519                 # conflict, this means our behaviour is similar to a standard
520                 # failed cherry-pick during rebase, with a dirty index to
521                 # resolve before manually running git commit --amend then git
522                 # rebase --continue.
523                 git commit --allow-empty --allow-empty-message --amend \
524                            --no-post-rewrite -n -q -C $sha1 &&
525                         pick_one -n $sha1 &&
526                         git commit --allow-empty --allow-empty-message \
527                                    --amend --no-post-rewrite -n -q -C $sha1 \
528                                    ${gpg_sign_opt:+"$gpg_sign_opt"} ||
529                                    die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
530         else
531                 pick_one $sha1 ||
532                         die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
533         fi
534 }
535
536 do_next () {
537         rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
538         read -r command sha1 rest < "$todo"
539         case "$command" in
540         "$comment_char"*|''|noop|drop|d)
541                 mark_action_done
542                 ;;
543         "$cr")
544                 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
545                 mark_action_done
546                 ;;
547         pick|p)
548                 comment_for_reflog pick
549
550                 mark_action_done
551                 do_pick $sha1 "$rest"
552                 record_in_rewritten $sha1
553                 ;;
554         reword|r)
555                 comment_for_reflog reword
556
557                 mark_action_done
558                 do_pick $sha1 "$rest"
559                 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
560                         warn "$(eval_gettext "\
561 Could not amend commit after successfully picking \$sha1... \$rest
562 This is most likely due to an empty commit message, or the pre-commit hook
563 failed. If the pre-commit hook failed, you may need to resolve the issue before
564 you are able to reword the commit.")"
565                         exit_with_patch $sha1 1
566                 }
567                 record_in_rewritten $sha1
568                 ;;
569         edit|e)
570                 comment_for_reflog edit
571
572                 mark_action_done
573                 do_pick $sha1 "$rest"
574                 sha1_abbrev=$(git rev-parse --short $sha1)
575                 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
576                 exit_with_patch $sha1 0
577                 ;;
578         squash|s|fixup|f)
579                 case "$command" in
580                 squash|s)
581                         squash_style=squash
582                         ;;
583                 fixup|f)
584                         squash_style=fixup
585                         ;;
586                 esac
587                 comment_for_reflog $squash_style
588
589                 test -f "$done" && has_action "$done" ||
590                         die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
591
592                 mark_action_done
593                 update_squash_messages $squash_style $sha1
594                 author_script_content=$(get_author_ident_from_commit HEAD)
595                 echo "$author_script_content" > "$author_script"
596                 eval "$author_script_content"
597                 if ! pick_one -n $sha1
598                 then
599                         git rev-parse --verify HEAD >"$amend"
600                         die_failed_squash $sha1 "$rest"
601                 fi
602                 case "$(peek_next_command)" in
603                 squash|s|fixup|f)
604                         # This is an intermediate commit; its message will only be
605                         # used in case of trouble.  So use the long version:
606                         do_with_author output git commit --amend --no-verify -F "$squash_msg" \
607                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
608                                 die_failed_squash $sha1 "$rest"
609                         ;;
610                 *)
611                         # This is the final command of this squash/fixup group
612                         if test -f "$fixup_msg"
613                         then
614                                 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
615                                         ${gpg_sign_opt:+"$gpg_sign_opt"} ||
616                                         die_failed_squash $sha1 "$rest"
617                         else
618                                 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
619                                 rm -f "$GIT_DIR"/MERGE_MSG
620                                 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
621                                         ${gpg_sign_opt:+"$gpg_sign_opt"} ||
622                                         die_failed_squash $sha1 "$rest"
623                         fi
624                         rm -f "$squash_msg" "$fixup_msg"
625                         ;;
626                 esac
627                 record_in_rewritten $sha1
628                 ;;
629         x|"exec")
630                 read -r command rest < "$todo"
631                 mark_action_done
632                 eval_gettextln "Executing: \$rest"
633                 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
634                 status=$?
635                 # Run in subshell because require_clean_work_tree can die.
636                 dirty=f
637                 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
638                 if test "$status" -ne 0
639                 then
640                         warn "$(eval_gettext "Execution failed: \$rest")"
641                         test "$dirty" = f ||
642                                 warn "$(gettext "and made changes to the index and/or the working tree")"
643
644                         warn "$(gettext "\
645 You can fix the problem, and then run
646
647         git rebase --continue")"
648                         warn
649                         if test $status -eq 127         # command not found
650                         then
651                                 status=1
652                         fi
653                         exit "$status"
654                 elif test "$dirty" = t
655                 then
656                         # TRANSLATORS: after these lines is a command to be issued by the user
657                         warn "$(eval_gettext "\
658 Execution succeeded: \$rest
659 but left changes to the index and/or the working tree
660 Commit or stash your changes, and then run
661
662         git rebase --continue")"
663                         warn
664                         exit 1
665                 fi
666                 ;;
667         *)
668                 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
669                 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
670                 if git rev-parse --verify -q "$sha1" >/dev/null
671                 then
672                         die_with_patch $sha1 "$fixtodo"
673                 else
674                         die "$fixtodo"
675                 fi
676                 ;;
677         esac
678         test -s "$todo" && return
679
680         comment_for_reflog finish &&
681         newhead=$(git rev-parse HEAD) &&
682         case $head_name in
683         refs/*)
684                 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
685                 git update-ref -m "$message" $head_name $newhead $orig_head &&
686                 git symbolic-ref \
687                   -m "$GIT_REFLOG_ACTION: returning to $head_name" \
688                   HEAD $head_name
689                 ;;
690         esac && {
691                 test ! -f "$state_dir"/verbose ||
692                         git diff-tree --stat $orig_head..HEAD
693         } &&
694         {
695                 test -s "$rewritten_list" &&
696                 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
697                 true # we don't care if this copying failed
698         } &&
699         hook="$(git rev-parse --git-path hooks/post-rewrite)"
700         if test -x "$hook" && test -s "$rewritten_list"; then
701                 "$hook" rebase < "$rewritten_list"
702                 true # we don't care if this hook failed
703         fi &&
704                 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
705
706         return 1 # not failure; just to break the do_rest loop
707 }
708
709 # can only return 0, when the infinite loop breaks
710 do_rest () {
711         while :
712         do
713                 do_next || break
714         done
715 }
716
717 expand_todo_ids() {
718         git rebase--helper --expand-ids
719 }
720
721 collapse_todo_ids() {
722         git rebase--helper --shorten-ids
723 }
724
725 # Switch to the branch in $into and notify it in the reflog
726 checkout_onto () {
727         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
728         output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
729         git update-ref ORIG_HEAD $orig_head
730 }
731
732 get_missing_commit_check_level () {
733         check_level=$(git config --get rebase.missingCommitsCheck)
734         check_level=${check_level:-ignore}
735         # Don't be case sensitive
736         printf '%s' "$check_level" | tr 'A-Z' 'a-z'
737 }
738
739 # The whole contents of this file is run by dot-sourcing it from
740 # inside a shell function.  It used to be that "return"s we see
741 # below were not inside any function, and expected to return
742 # to the function that dot-sourced us.
743 #
744 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
745 # construct and continue to run the statements that follow such a "return".
746 # As a work-around, we introduce an extra layer of a function
747 # here, and immediately call it after defining it.
748 git_rebase__interactive () {
749
750 case "$action" in
751 continue)
752         if test ! -d "$rewritten"
753         then
754                 exec git rebase--helper ${force_rebase:+--no-ff} --continue
755         fi
756         # do we have anything to commit?
757         if git diff-index --cached --quiet HEAD --
758         then
759                 # Nothing to commit -- skip this commit
760
761                 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
762                 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
763                 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
764         else
765                 if ! test -f "$author_script"
766                 then
767                         gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
768                         die "$(eval_gettext "\
769 You have staged changes in your working tree.
770 If these changes are meant to be
771 squashed into the previous commit, run:
772
773   git commit --amend \$gpg_sign_opt_quoted
774
775 If they are meant to go into a new commit, run:
776
777   git commit \$gpg_sign_opt_quoted
778
779 In both cases, once you're done, continue with:
780
781   git rebase --continue
782 ")"
783                 fi
784                 . "$author_script" ||
785                         die "$(gettext "Error trying to find the author identity to amend commit")"
786                 if test -f "$amend"
787                 then
788                         current_head=$(git rev-parse --verify HEAD)
789                         test "$current_head" = $(cat "$amend") ||
790                         die "$(gettext "\
791 You have uncommitted changes in your working tree. Please commit them
792 first and then run 'git rebase --continue' again.")"
793                         do_with_author git commit --amend --no-verify -F "$msg" -e \
794                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
795                                 die "$(gettext "Could not commit staged changes.")"
796                 else
797                         do_with_author git commit --no-verify -F "$msg" -e \
798                                 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
799                                 die "$(gettext "Could not commit staged changes.")"
800                 fi
801         fi
802
803         if test -r "$state_dir"/stopped-sha
804         then
805                 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
806         fi
807
808         require_clean_work_tree "rebase"
809         do_rest
810         return 0
811         ;;
812 skip)
813         git rerere clear
814
815         if test ! -d "$rewritten"
816         then
817                 exec git rebase--helper ${force_rebase:+--no-ff} --continue
818         fi
819         do_rest
820         return 0
821         ;;
822 edit-todo)
823         git stripspace --strip-comments <"$todo" >"$todo".new
824         mv -f "$todo".new "$todo"
825         collapse_todo_ids
826         append_todo_help
827         gettext "
828 You are editing the todo file of an ongoing interactive rebase.
829 To continue rebase after editing, run:
830     git rebase --continue
831
832 " | git stripspace --comment-lines >>"$todo"
833
834         git_sequence_editor "$todo" ||
835                 die "$(gettext "Could not execute editor")"
836         expand_todo_ids
837
838         exit
839         ;;
840 esac
841
842 comment_for_reflog start
843
844 if test ! -z "$switch_to"
845 then
846         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
847         output git checkout "$switch_to" -- ||
848                 die "$(eval_gettext "Could not checkout \$switch_to")"
849
850         comment_for_reflog start
851 fi
852
853 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
854 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
855
856 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
857 write_basic_state
858 if test t = "$preserve_merges"
859 then
860         if test -z "$rebase_root"
861         then
862                 mkdir "$rewritten" &&
863                 for c in $(git merge-base --all $orig_head $upstream)
864                 do
865                         echo $onto > "$rewritten"/$c ||
866                                 die "$(gettext "Could not init rewritten commits")"
867                 done
868         else
869                 mkdir "$rewritten" &&
870                 echo $onto > "$rewritten"/root ||
871                         die "$(gettext "Could not init rewritten commits")"
872         fi
873         # No cherry-pick because our first pass is to determine
874         # parents to rewrite and skipping dropped commits would
875         # prematurely end our probe
876         merges_option=
877 else
878         merges_option="--no-merges --cherry-pick"
879 fi
880
881 shorthead=$(git rev-parse --short $orig_head)
882 shortonto=$(git rev-parse --short $onto)
883 if test -z "$rebase_root"
884         # this is now equivalent to ! -z "$upstream"
885 then
886         shortupstream=$(git rev-parse --short $upstream)
887         revisions=$upstream...$orig_head
888         shortrevisions=$shortupstream..$shorthead
889 else
890         revisions=$onto...$orig_head
891         shortrevisions=$shorthead
892 fi
893 if test t != "$preserve_merges"
894 then
895         git rebase--helper --make-script ${keep_empty:+--keep-empty} \
896                 $revisions ${restrict_revision+^$restrict_revision} >"$todo"
897 else
898         format=$(git config --get rebase.instructionFormat)
899         # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
900         git rev-list $merges_option --format="%m%H ${format:-%s}" \
901                 --reverse --left-right --topo-order \
902                 $revisions ${restrict_revision+^$restrict_revision} | \
903                 sed -n "s/^>//p" |
904         while read -r sha1 rest
905         do
906
907                 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
908                 then
909                         comment_out="$comment_char "
910                 else
911                         comment_out=
912                 fi
913
914                 if test -z "$rebase_root"
915                 then
916                         preserve=t
917                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
918                         do
919                                 if test -f "$rewritten"/$p
920                                 then
921                                         preserve=f
922                                 fi
923                         done
924                 else
925                         preserve=f
926                 fi
927                 if test f = "$preserve"
928                 then
929                         touch "$rewritten"/$sha1
930                         printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
931                 fi
932         done
933 fi
934
935 # Watch for commits that been dropped by --cherry-pick
936 if test t = "$preserve_merges"
937 then
938         mkdir "$dropped"
939         # Save all non-cherry-picked changes
940         git rev-list $revisions --left-right --cherry-pick | \
941                 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
942         # Now all commits and note which ones are missing in
943         # not-cherry-picks and hence being dropped
944         git rev-list $revisions |
945         while read rev
946         do
947                 if test -f "$rewritten"/$rev &&
948                    ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
949                 then
950                         # Use -f2 because if rev-list is telling us this commit is
951                         # not worthwhile, we don't want to track its multiple heads,
952                         # just the history of its first-parent for others that will
953                         # be rebasing on top of it
954                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
955                         sha1=$(git rev-list -1 $rev)
956                         sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
957                         rm "$rewritten"/$rev
958                 fi
959         done
960 fi
961
962 test -s "$todo" || echo noop >> "$todo"
963 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
964 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
965
966 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
967 todocount=${todocount##* }
968
969 cat >>"$todo" <<EOF
970
971 $comment_char $(eval_ngettext \
972         "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
973         "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
974         "$todocount")
975 EOF
976 append_todo_help
977 gettext "
978 However, if you remove everything, the rebase will be aborted.
979
980 " | git stripspace --comment-lines >>"$todo"
981
982 if test -z "$keep_empty"
983 then
984         printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
985 fi
986
987
988 has_action "$todo" ||
989         return 2
990
991 cp "$todo" "$todo".backup
992 collapse_todo_ids
993 git_sequence_editor "$todo" ||
994         die_abort "$(gettext "Could not execute editor")"
995
996 has_action "$todo" ||
997         return 2
998
999 git rebase--helper --check-todo-list || {
1000         ret=$?
1001         checkout_onto
1002         exit $ret
1003 }
1004
1005 expand_todo_ids
1006
1007 test -d "$rewritten" || test -n "$force_rebase" ||
1008 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
1009 die "Could not skip unnecessary pick commands"
1010
1011 checkout_onto
1012 if test -z "$rebase_root" && test ! -d "$rewritten"
1013 then
1014         require_clean_work_tree "rebase"
1015         exec git rebase--helper ${force_rebase:+--no-ff} --continue
1016 fi
1017 do_rest
1018
1019 }
1020 # ... and then we call the whole thing.
1021 git_rebase__interactive